<template>
  <div class="login-page">
    <div class="login-container">
      <div class="login">
        <form class="login-form" @submit.prevent="submit">
          <span class="title">
            <span>*</span>
            User name
          </span>
          <input type="text" maxlength="50" class="input" v-model="username.value">
          <span class="title">
            <span>*</span>
            Password
          </span>
          <input type="password" maxlength="50" class="input" v-model="password.value">
          <div class="login-button-container">
            <Spinner v-if="loading" :width="40" :height="40" />
            <input type="submit" class="login-button" value="Log In">
          </div>
        </form>
        <div class="signup-title">Not yet have an account?</div>
        <div @click="$router.push('/registration')" class="signup-btn rtrLnk">Sign Up</div>
      </div>
    </div>
  </div>
</template>
<script>
import { mapGetters } from 'vuex'
import { MODAL, PROFILE } from '../store/types'
import Spinner from '@/components/Spinner'
export default {
  name: 'LoginPage',
  components: {
    Spinner
  },
  data: () => ({
    username: {
      value: null,
      error: null
    },
    password: {
      value: null,
      error: null
    }
  }),
  computed: {
    ...mapGetters({
      loading: PROFILE.GETTER.GET_LOGIN_LOADING
    })
  },
  methods: {
    async submit () {
      if (!(this.username.value && this.password.value)) {
        this.username.error = 'This field cannot be empty'
        this.password.error = 'This field cannot be empty'
        this.$store.commit(MODAL.MUTATION.SET_IS_MODAL_OPEN, true)
        this.$store.commit(MODAL.MUTATION.SET_MODAL_CONTENT, 'Some fields are not filled')
        this.$store.commit(MODAL.MUTATION.SET_MODAL_ICON, 'error')
        return
      }

      const result = await this.$store.dispatch(PROFILE.ACTION.LOGIN, { login: this.username.value, password: this.password.value })

      if (!result.error) this.$router.push('/')
      else if (result.error) {
        this.$store.commit(MODAL.MUTATION.SET_IS_MODAL_OPEN, true)
        this.$store.commit(MODAL.MUTATION.SET_MODAL_CONTENT, `Error on login: ${result.err}`)
        this.$store.commit(MODAL.MUTATION.SET_MODAL_ICON, 'error')
      }
    }
  }
}
</script>
<style scoped lang="scss">
.login-page {
  display: flex;
  // justify-content: center;
  margin-top: 15vh;
  align-items: center;
  flex-direction: column;
  height: calc(100vh - 237px);
}

.login-container {
  position: relative;
  display: flex;
  align-items: center;
  flex-direction: column;
  max-width: 356px;
  width: 100%;
}

.login {
  max-width: 356px;
  width: 100%;
  display: flex;
  flex-direction: column;
}

.login-form {
  width: 100%;
  display: flex;
  flex-direction: column;
  margin-bottom: 20px;

  & .title {
    margin-bottom: 8px;
    width: 100%;
    text-align: start;
    & span {
      color: red;
    }
  }

  & .input {
    width: 100%;
    height: 32px;
    border: 1px solid rgba(0, 0, 0, 0.15);
    box-sizing: border-box;
    border-radius: 4px;
    margin-bottom: 13px;
  }

  & .login-button-container {
    position: relative;
  }

  & .login-button {
    background: #1890FF;
    width: 100%;
    border: 1px solid #1890FF;
    box-sizing: border-box;
    border-radius: 5px;
    color: white;
    height: 48px;
    font-family: $base_font;
    font-size: 18px;
    cursor: pointer;
    transition: 0.3s;

    &:hover {
      opacity: 0.8;
    }
  }
}
.signup-title {
  font-family: $base_font;
  font-weight: normal;
  font-size: 14px;
  line-height: 22px;
  color: #3A3F45;
  text-align: start;
  margin-bottom: 3px;
}
.signup-btn {
  width: 100%;
  height: 48px;
  background: #FFFFFF;
  border: 1px solid #1890FF;
  box-sizing: border-box;
  border-radius: 5px;
  font-family: $base_font;
  font-size: 18px;
  color: #1890FF;
  cursor: pointer;
  transition: 0.3s;
  display: flex;
  justify-content: center;
  align-items: center;
  &:hover {
    opacity: 0.7;
  }
}
</style>
